<template>

  <v-container fluid>

    <v-card-actions>
      <v-spacer />
      <v-text-field
        name="Grado-text" label="Búsqueda" v-model="grados.tabla.busqueda"
        style="border-radius: 10px; max-width: 300px;" clearable dense
        prepend-inner-icon="mdi-magnify" outlined color="white"
      />
    </v-card-actions>

    <v-card>

      <v-data-table
        :headers="grados.tabla.headers" :items="grados.listado" class="elevation-0"
        hide-default-footer :items-per-page="grados.tabla.gradosPorPagina"
        :page.sync="grados.tabla.pagina" @page-count="grados.tabla.conteoPaginas = $event"
        :loading="grados.tabla.loading" :custom-filter="Busqueda" :search="grados.tabla.busqueda"
        loading-text="Cargando... por favor espere"
      >

        <template v-slot:no-data>

          <v-alert prominent type="info" color="blue darken-1">
            No hay grados disponibles para mostrar en este momento, vuelva a intentarlo.
          </v-alert>

        </template>

        <template v-slot:no-results>

          <v-alert prominent type="info" color="blue darken-1">
            No hay resultados encontrados con la búsqueda "{{ grados.tabla.busqueda }}".
          </v-alert>

        </template>

        <template v-slot:top>

          <v-toolbar height="80" flat style="border-radius: 10px;">
            <v-toolbar-title>
              Administrar grados
            </v-toolbar-title>
            <v-spacer />
            <v-btn color="blue darken-1" @click="MostrarDialogoNuevoGrado">
              <v-icon left size="25">mdi-plus</v-icon>
              Nuevo Grado
            </v-btn>
          </v-toolbar>

        </template>

        <template v-slot:[`item.profesor`] = "{ item }">

          <span>
            {{ item.profesor ?
            item.profesor.nombre + ' ' + item.profesor.apellidos : '-' }}
          </span>

        </template>

        <template v-slot:[`item.acciones`] = "{ item }">

          <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                color="amber darken-1" dark v-bind="attrs" v-on="on"
                @click="MostrarDialogoEditarGrado(item)" icon
              >

                <v-icon> mdi-pencil </v-icon>

              </v-btn>
            </template>
            <span>Editar Grado</span>
          </v-tooltip>

          <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                color="error" dark v-bind="attrs" v-on="on"
                @click="EliminarGrado(item)" icon
              >

                <v-icon> mdi-delete </v-icon>

              </v-btn>
            </template>
            <span>Eliminar Grado</span>
          </v-tooltip>

        </template>

      </v-data-table>

      <v-divider/>

      <v-pagination
        class="py-3" v-model="grados.tabla.pagina"
        :length="grados.tabla.conteoPaginas" total-visible="10"
      >

      </v-pagination>

    </v-card>

    <NuevoEditarGrado
      v-model="dialogos.grado" :grado.sync="grados.seleccionado"
      :profesores.sync="profesores" @refresh="ObtenerGrados"
    />

  </v-container>

</template>


<script>

import NuevoEditarGrado from "~/components/grados/NuevoEditarGrado";

export default {

  components: { NuevoEditarGrado  },

  mounted() {

    this.ObtenerGrados()

  },

  data(){

    return {

      dialogos: {

        grado: false

      },

      grados: {

        listado: [],
        seleccionado: {},
        tabla: {

          headers: [
            { text: 'ID', value: 'idGrado', align: 'center' },
            { text: 'Grado', value: 'nombre', align: 'center' },
            { text: 'Profesor Encargado', value: 'profesor', align: 'center' },
            { text: 'Acciones', value: 'acciones', align: 'center' },
          ],
          busqueda: null,
          loading: false,
          pagina: 1,
          conteoPaginas: 0,
          gradosPorPagina: 10

        }

      },

      profesores: []

    }

  },

  methods: {

    async ObtenerGrados(){

      this.grados.tabla.loading = true

      let config = { timeout: 5000 }

      await this.$axios.get("/grados", config).then(({data}) => {

        this.grados.listado = data
        this.grados.tabla.loading = false

      })

    },

    async ObtenerProfesores(){

      let config = { timeout: 5000 }

      await this.$axios.get("/profesores", config).then(({data}) => {

        this.profesores = data

      })

    },

    async EliminarGrado(grado){

      let config = { timeout: 5000 }

      await this.$axios.post("/grados/eliminar/" + grado.idGrado, {}, config).then(({data}) => {

        this.ObtenerGrados()

      })

    },

    Busqueda(value, search, item){

      let nombre = RegExp(search, 'i').test(item.nombre)
      let apellidos = RegExp(search, 'i').test(item.apellidos)

      return nombre | apellidos

    },

    MostrarDialogoNuevoGrado(){

      this.ObtenerProfesores()
      this.dialogos.grado = true

    },

    MostrarDialogoEditarGrado(grado){

      this.grados.seleccionado = Object.assign({}, grado)
      this.ObtenerProfesores()
      this.dialogos.grado = true

    }

  }

}

</script>
